///home/berryj/link/bin/genMethods "-g" "-t" "Vertex*" "-h" "Set" "-r" "MSet<Vertex*>" "-I" "LINK/basic/Set.h" "-I" "LINK/graph/Vertex.h" "-d" "graph" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/basic/Set.h>

#include <LINK/graph/Vertex.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/CollectionWrapper.h>


typedef Vertex* _Vertex_;
typedef Set<Vertex* > _Set_Vertex__;
static Set<Vertex* > s__Set_Vertex__;

#define _Set_Vertex__DATA(x) ((Set<Vertex* >*) (EXTDATA(x)))
#define _Set_Vertex__IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Set<Vertex* > >::type))
#define _Set_Vertex__ISNT_DATA(x) (!_Set_Vertex__IS_DATA(x))

#define _Set_Vertex__CXX_DATA(x) (*(Set<Vertex* >*) (EXTDATA(VAL(x))))
#define _Set_Vertex__CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Set<Vertex* > >::type))
#define _Set_Vertex__CXX_ISNT_DATA(x) (!_Set_Vertex__CXX_IS_DATA(x))


PRIMITIVE STk_init__Set_Vertex__()
{
	Wrapper<_Set_Vertex__>::type = STk_new_CXXwrapper_id(
			Wrapper<_Set_Vertex__>::name, 
			Wrapper<MSet<Vertex*> >::name,
			(void (*)(SCM x, SCM port, int mode))
			CollectionWrapper<_Vertex_>::displayTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_Vertex_>::markTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_Vertex_>::freeTypedCollection);
	Tcl_InitHashTable(&Register<_Set_Vertex__>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_Set_Vertex__Methods(void);

PRIMITIVE STk_init_methods__Set_Vertex__()
{
	genExtra_Set_Vertex__Methods();
	return UNDEFINED;
}
